Процедура ДополнитьМассив(Приемник, Источник) Экспорт
	
	Для Каждого Элемент Из Источник Цикл
		Приемник.Добавить(Элемент);
	КонецЦикла;
	
КонецПроцедуры

Процедура ДополнитьТаблицуЗначений(Приемник, Источник) Экспорт
	
	Для Каждого Элемент Из Источник Цикл
		НоваяСтрокаПриемника = Приемник.Добавить();
		ЗаполнитьЗначенияСвойств(НоваяСтрокаПриемника, Элемент);
	КонецЦикла;
	
КонецПроцедуры

// Дополняет соответствие значениями из источника
//
// Параметры:
//   Приемник - Соответствие - Дополняемое соответствие
//   Источник - Соответствие - Исходное соответствие для дополнения
//
Процедура ДополнитьСоответствие(Приемник, Источник) Экспорт
	
	Для Каждого КлючИЗначение Из Источник Цикл
		Приемник.Вставить(КлючИЗначение.Ключ, КлючИЗначение.Значение);
	КонецЦикла;
	
КонецПроцедуры

// Дополняет структуру значениями из источника
//
// Параметры:
//   Приемник - Структура - Дополняемая структура
//   Источник - Структура - Исходная структура для дополнения
//
Процедура ДополнитьСтруктуру(Приемник, Источник) Экспорт
	
	Для Каждого КлючИЗначение Из Источник Цикл
		Приемник.Вставить(КлючИЗначение.Ключ, КлючИЗначение.Значение);
	КонецЦикла;
	
КонецПроцедуры

// Создает копию соответствия
//
// Параметры:
//   Источник - Соответствие - Исходное соответствие для копирования
//
// Возвращаемое значение:
//   Соответствие - Новое соответствие с скопированными данными
//
Функция СкопироватьСоответствие(Источник) Экспорт
	
	НовоеСоответствие = Новый Соответствие;
	
	Для Каждого КлючИЗначение Из Источник Цикл
		НовоеСоответствие.Вставить(КлючИЗначение.Ключ, КлючИЗначение.Значение);
	КонецЦикла;
	
	Возврат НовоеСоответствие;
	
КонецФункции

// Создает копию структуры
//
// Параметры:
//   Источник - Структура - Исходная структура для копирования
//
// Возвращаемое значение:
//   Структура - Новая структура с скопированными данными
//
Функция СкопироватьСтруктуру(Источник) Экспорт
	
	НоваяСтруктура = Новый Структура;
	
	Для Каждого КлючИЗначение Из Источник Цикл
		НоваяСтруктура.Вставить(КлючИЗначение.Ключ, КлючИЗначение.Значение);
	КонецЦикла;
	
	Возврат НоваяСтруктура;
	
КонецФункции

// Создает копию массива
//
// Параметры:
//   Источник - Массив - Исходный массив для копирования
//
// Возвращаемое значение:
//   Массив - Новый массив с скопированными данными
//
Функция СкопироватьМассив(Источник) Экспорт
	
	НовыйМассив = Новый Массив;
	
	Для Каждого Элемент Из Источник Цикл
		НовыйМассив.Добавить(Элемент);
	КонецЦикла;
	
	Возврат НовыйМассив;
	
КонецФункции

Функция ТаблицаЗначенийВМассив(ТаблицаЗначений) Экспорт
	
	Массив = Новый Массив;
	
	Для Каждого Строка Из ТаблицаЗначений Цикл
		СтруктураСтроки = Новый Структура;
		Для Каждого Колонка Из ТаблицаЗначений.Колонки Цикл
			СтруктураСтроки.Вставить(Колонка.Имя, Строка[Колонка.Имя]);
		КонецЦикла;
		Массив.Добавить(СтруктураСтроки);
	КонецЦикла;
	
	Возврат Массив;
	
КонецФункции